Attribute VB_Name = "FtpModule"
Option Explicit

Public Type URL
    Service As String
    User As String
    Pass As String
    Host As String
    Port As Long
    Path As String
End Type

Public Function ParseURL(ByVal theURL As String) As URL
    'ftp://anonymous:me@myself.net@localhost:666/hrhrhr/
    Dim Result As URL
    Dim f As Long
    
    f = InStr(theURL, ":")
    If f = 0 Then
        Result.Service = "file"
    Else
        Result.Service = Left$(theURL, f - 1)
        theURL = Right$(theURL, Len(theURL) - f)
        If AZLeftGleich(theURL, "//") Then theURL = Right$(theURL, Len(theURL) - 2)
    End If
    'anonymous:me@myself.net@localhost:666/hrhrhr/
    
    f = InStr(theURL, "/")
    If f = 0 Then
        Result.Path = "/"
    Else
        Result.Path = Right$(theURL, Len(theURL) - f + 1)
        theURL = Left$(theURL, f - 1)
    End If
    'anonymous:me@myself.net@localhost:666
    
    Dim Server As String
    f = InStrRev(theURL, "@")
    Server = Right$(theURL, Len(theURL) - f)
    If f = 0 Then
        Result.User = ""
        Result.Pass = ""
    Else
        theURL = Left$(theURL, f - 1)
        'anonymous:me@myself.net
        
        f = InStr(theURL, ":")
        If f = 0 Then
            Result.User = theURL
            Result.Pass = ""
        Else
            Result.User = Left$(theURL, f - 1)
            Result.Pass = Right$(theURL, Len(theURL) - f)
        End If
    End If
    theURL = Server
    'localhost:666
    
    f = InStr(theURL, ":")
    If f = 0 Then
        Result.Host = theURL
        Select Case LCase$(Result.Service)
            Case "http"
                Result.Port = 80
            Case "ftp"
                Result.Port = 21
            Case "telnet"
                Result.Port = 23
            Case Else
                Result.Port = 0
        End Select
    Else
        Result.Host = Left$(theURL, f - 1)
        Result.Port = Val(Right$(theURL, Len(theURL) - f))
    End If
        
    ParseURL = Result
End Function
