VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form MainForm 
   Caption         =   "FtpContentChecker"
   ClientHeight    =   4710
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6765
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   314
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   451
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer CheckTimer 
      Interval        =   1000
      Left            =   840
      Tag             =   "0"
      Top             =   3840
   End
   Begin VB.PictureBox DividingLine 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'Kein
      Height          =   3375
      Left            =   2760
      MousePointer    =   9  'Grennderung W O
      ScaleHeight     =   225
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   5
      TabIndex        =   2
      Top             =   0
      Width           =   75
   End
   Begin MSComctlLib.ListView Files 
      Height          =   3375
      Left            =   2880
      TabIndex        =   1
      Top             =   0
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   5953
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FlatScrollBar   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   0
      BackColor       =   8421504
      Appearance      =   0
      NumItems        =   0
   End
   Begin MSComctlLib.ListView URLs 
      Height          =   3375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2775
      _ExtentX        =   4895
      _ExtentY        =   5953
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FlatScrollBar   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   0
      BackColor       =   8421504
      Appearance      =   0
      NumItems        =   0
   End
   Begin VB.Menu mnuRefresh 
      Caption         =   "&Refresh"
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
   Begin VB.Menu mnuAbout 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private myPositionSaver As PositionSaver
Private WithEvents myMainInterface As MainInterface
Attribute myMainInterface.VB_VarHelpID = -1

Private Sub CheckTimer_Timer()
    Dim Interval As Long
    Interval = Val(GetOption(Verz + "interval.dat", Str$(5 * 60)))
    If Interval = 0 Then Exit Sub
    
    CheckTimer.Tag = Str$(Val(CheckTimer.Tag) + 1)
    If Val(CheckTimer.Tag) > Interval Then
        myMainInterface.CheckFiles
        CheckTimer.Tag = "0"
    End If
End Sub

Private Sub DividingLine_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then SetDividingLinePosition DividingLine.Left + (X - DividingLine.Width / 2)
End Sub

Private Sub SetDividingLinePosition(ByVal X As Long)
    DividingLine.Left = X
    Form_Resize
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case 45 'Ins
            URLs.ListItems.Add(, , "ftp://").Selected = True
            URLs.SetFocus
            URLs.StartLabelEdit
        Case 46 'Del
            If Not URLs.SelectedItem Is Nothing Then
                myMainInterface.RemoveURL URLs.SelectedItem.Text
                URLs.ListItems.Remove URLs.SelectedItem.Index
            End If
        Case 13 'Enter
            URLs_DblClick
        Case 113 'F2
            If Not URLs.SelectedItem Is Nothing Then
                URLs.SetFocus
                URLs.StartLabelEdit
            End If
        Case 112 'F1
            mnuHelp_Click
        Case 16, 17, 18 'Ctrl, Alt, Shift
            'ignore
        Case Else
            'MsgBox KeyCode
    End Select
End Sub

Private Sub Form_Load()
    Set myPositionSaver = New PositionSaver
    myPositionSaver.SetFormName "MainForm"
    myPositionSaver.SetForm Me
    myPositionSaver.LoadPosition
    SetDividingLinePosition Val(GetOption(Verz + "MainForm_DividingLine.pos", Str$(DividingLine.Left)))
    
    URLs.ColumnHeaders.Add , , "URL", Screen.Width
    Files.ColumnHeaders.Add , , "Content", Screen.Width
    
    Set myMainInterface = MainInterface_Modul.myMainInterface
    
    Dim i As Long
    For i = 1 To myMainInterface.GetURLsCount()
        URLs.ListItems.Add , , myMainInterface.GetURL(i).URL
    Next
    myMainInterface_Change
    ShowFiles
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    URLs.Width = DividingLine.Left
    URLs.Height = Me.ScaleHeight
    DividingLine.Height = Me.ScaleHeight
    Files.Left = DividingLine.Left + DividingLine.Width
    Files.Width = Me.ScaleWidth - Files.Left
    Files.Height = Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
    myPositionSaver.SavePosition
    Set myPositionSaver = Nothing
    SetOption Verz + "MainForm_DividingLine.pos", Str$(DividingLine.Left)

    ExitProg
End Sub

Private Sub mnuAbout_Click()
    AboutForm.Show 1
End Sub

Private Sub mnuHelp_Click()
    Dim Text As String
    Text = "menue:" + endl
    Text = Text + Chr$(9) + "Refresh (Alt + r): refreshs state of old and new files" + endl
    Text = Text + Chr$(9) + "Options (Alt + o): opens a dialog with changeable options" + endl
    Text = Text + Chr$(9) + "Help (Alt + h): opens this dialog" + endl
    Text = Text + Chr$(9) + "About (Alt + a): opens a dialog with informations about the coder" + endl
    Text = Text + endl
    Text = Text + "keys:" + endl
    Text = Text + Chr$(9) + "F1: opens this dialog" + endl
    Text = Text + Chr$(9) + "Ins: inserts a new URL" + endl
    Text = Text + Chr$(9) + "F2: edits selected URL" + endl
    Text = Text + Chr$(9) + "Del: deletes selected URL" + endl
    Text = Text + Chr$(9) + "Enter: checks selected URL for new files" + endl
    Text = Text + Chr$(9) + "Alt + F4: exits this tool" + endl
    Text = Text + endl
    Text = Text + "URLs-properties:" + endl
    Text = Text + Chr$(9) + "bold: new or old files" + endl
    Text = Text + Chr$(9) + "grey: checking" + endl
    Text = Text + Chr$(9) + "red: error" + endl
    Text = Text + endl
    Text = Text + "Content-properties:" + endl
    Text = Text + Chr$(9) + "bold: new file" + endl
    Text = Text + Chr$(9) + "grey: old file" + endl
    Text = Text + endl
    Text = Text + "Send me a mail for more questions."
    MsgBox Text, , "Help"
End Sub

Private Sub mnuOptions_Click()
    OptionsForm.Show 1
End Sub

Private Sub mnuRefresh_Click()
    myMainInterface.Refresh
End Sub

Private Sub myMainInterface_Change()
    Dim i As Long
    Dim fList As UrlFileList
    For i = 1 To URLs.ListItems.Count
        Set fList = myMainInterface.GetURL(myMainInterface.GetURLIndex(URLs.ListItems(i).Text))
        If Not fList Is Nothing Then
            If fList.IsChecking() Then
                URLs.ListItems(i).ForeColor = RGB(80, 80, 80)
            ElseIf fList.IsError() Then
                URLs.ListItems(i).ForeColor = RGB(255, 0, 0)
            Else
                URLs.ListItems(i).ForeColor = RGB(0, 0, 0)
            End If
            URLs.ListItems(i).Bold = fList.IsChanged()
        End If
    Next
    ShowFiles
End Sub

Private Sub URLs_AfterLabelEdit(Cancel As Integer, NewString As String)
    Dim theURL As UrlFileList
    Dim Index As Long
    Index = myMainInterface.GetURLIndex(URLs.SelectedItem.Text)
    If Index = 0 Then
        Index = myMainInterface.AddURL(NewString)
    Else
        Set theURL = myMainInterface.GetURL(Index)
        theURL.URL = NewString
        theURL.CheckFiles
    End If
End Sub

Private Sub URLs_Click()
    ShowFiles
End Sub

Private Sub URLs_DblClick()
    If URLs.SelectedItem Is Nothing Then Exit Sub
    myMainInterface.GetURL(myMainInterface.GetURLIndex(URLs.SelectedItem.Text)).CheckFiles
End Sub

Private Sub URLs_ItemCheck(ByVal Item As MSComctlLib.ListItem)
    ShowFiles
End Sub

Private Sub ShowFiles()
    Files.ListItems.Clear
    If URLs.SelectedItem Is Nothing Then Exit Sub
    Dim i As Long
    Dim fList As UrlFileList
    Set fList = myMainInterface.GetURL(myMainInterface.GetURLIndex(URLs.SelectedItem.Text))
    If fList Is Nothing Then Exit Sub
    Dim lItem As ListItem
    For i = 1 To fList.GetFilesCount()
        Set lItem = Files.ListItems.Add(, , fList.GetFileName(i))
        Select Case fList.GetFileState(i)
            Case FileState.fsNew
                lItem.Bold = True
            Case FileState.fsOld
                lItem.ForeColor = RGB(80, 80, 80)
        End Select
    Next
End Sub

Private Sub URLs_ItemClick(ByVal Item As MSComctlLib.ListItem)
    ShowFiles
End Sub
